/*
 *	essai sur la vision exterieure d'un batiment
 *
 *			see the snapshooot system
 */

#version 3.7;

global_settings {
		ambient_light rgb <0.39, 0.39, 0.39>
		assumed_gamma 1.0
		max_trace_level 4
		}

/* system includes */
#include  "colors.inc"
#include  "textures.inc"
#include  "stones.inc"
#include  "woods.inc"
#include  "metals.inc"
#include  "glass.inc"

/* my includes */
#include  "values.inc"
#include  "reperes.inc"
#include  "vaisselle.inc"
#include  "meubles.inc"
#include  "cubes.inc"				// added Sun 08 Jan 2023
#include  "supports.inc"			// new Thu 22 Dec 2022
#include  "lumieres.inc"
#include  "elements.inc"
#include  "decorations.inc"
#include  "grostrucs.inc"
#include  "bidules.inc"
#include  "univers.inc"
#include  "rotonde.inc"
#include  "lumieres.inc"
#include  "monster.inc"
#include  "steles.inc"
#include  "jardin.inc"
#include  "chateau.inc"

#include  "annexe.inc"				// new 2022-01-27

/*    ------------------------------------------------------    */

#declare  ShowWall = 0;
#include  "batiment.inc"

#include "assemblage.inc"
object { Assemblage_Final }

object { Balise_Orange scale 2 translate < 50, 0, -50> }
object { Balise_Orange scale 2 translate <-50, 0, -50> }
object { Balise_Orange scale 2 translate <-50, 0,  50> }

/*    ------------------------------------------------------    */

#macro compute_MyClock ( param )
  #declare value = ((param / NbImg) * 4.185) - 0.55;
  value
#end

#declare MyClock = compute_MyClock( clock );

#include  "paramove.inc"

#declare Begin_Cam   = <-50,  66,  145>;
#declare End_Cam     = < 108, 24, -90>;
#declare Pos_Cam     = Interpolate(Begin_Cam, End_Cam, NormClock);
#declare Pos_Cam     = Pos_Cam + <0, 41*Cos_010(NormClock), 0>;

#local Lat_Cam       =   <3.70 - NormClock, 0.80, 0.17>;
#local AngleCam      =   53.70 + (8.92 * Cos_010(NormClock));

#declare T_mark = 0.15;

#declare Trajectoire_LOC = object
{
union {
	#for (foo, 0, 2000)
	  #local XYZ = LOC_camera( foo/NbImg );
	  // #debug concat ("trajloccam ", vstr(3, XYZ, "  ", 6, 3), "\n")
	  // #debug concat ("camera X   ", str(XYZ.x, 6, 3), "\n")
	  object { sphere { XYZ, T_mark } }
	#end
	}
texture {
	pigment { color Cyan } 
	}
}

#declare Trajectoire_LAT = object
{
union {
	#for (foo, 0, 2000)
	  #local XYZ = LAT_camera( foo/NbImg );
	  // #debug concat ("trajlatcam ", vstr(3, XYZ, "  ", 6, 3), "\n")
	  // #debug concat ("camera X   ", str(XYZ.x, 6, 3), "\n")
	  object { sphere { XYZ, T_mark } }
	#end
	}
texture {
	pigment { color Magenta } 
	}
}

#if (mod(clock, 90) < 20)			// XXX
// #if (1)
object { Trajectoire_LOC }
object { Trajectoire_LAT }
object {
	cylinder { LOC_camera(NormClock), LAT_camera(NormClock), T_mark*0.92 }
	pigment { color Yellow }
	}
#end

object { Marker scale 8 translate <14, 19, -5> }

camera	{
	location	Pos_Cam
	look_at		Lat_Cam
	right		x*image_width/image_height
	angle 		AngleCam
	}

/*    ------------------------------------------------------    */
